define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Baas = require("$UI/HondaApp/js/baas");
	
	var shopID = "";
	var editState = "";
	var fID = "";

	var Model = function(){
		this.callParent();
	};

	Model.prototype.backBtnClick = function(){
		this.comp("windowReceiver1").windowCancel();
	};

	Model.prototype.typeDataCustomRefresh = function(event){
		var data = event.source;
		var params = {		
				"columns" : Baas.getDataColumns(data),
				"limit" : event.limit,	// 分页信息 – 行数
				"offset" : event.offset,  // 分页信息 – 行偏移
				"fScope" : "活动类型"
		};

		var success = function(resultData) {
			var append = event.options && event.options.append;
			data.loadData(resultData, append);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "queryTCommon",
			"params" : params,
			"success" : success
		});
	};

	Model.prototype.windowReceiver1Receive = function(event){
		shopID = event.data.shopID;
		editState = event.data.editState;
		fID =  event.data.fID;
		if (editState == "new"){
			this.comp("ActivityData").newData();
			this.comp("ActivityData").setValue("fType", "1");
			this.comp("ActivityData").setValue("fState", "1");
		} else {
			this.comp("ActivityData").refreshData();
		}
	};

	Model.prototype.ActivityDataCustomRefresh = function(event){
		
		var data = event.source;
		var params = {		
				"columns" : Baas.getDataColumns(data),
				"limit" : event.limit,	// 分页信息 – 行数
				"offset" : event.offset,  // 分页信息 – 行偏移
				"fCusShopID" : shopID,
				"fID" : fID
		};

		var success = function(resultData) {
			var append = event.options && event.options.append;
			data.loadData(resultData, append);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "queryTOrgnizeActivity",
			"params" : params,
			"success" : success
		});
	};

	Model.prototype. bespokeBtnClick = function(event){
		var data = event.source;
		var params = {		
				"columns" : Baas.getDataColumns(data),
				"limit" : event.limit,	// 分页信息 – 行数
				"offset" : event.offset,  // 分页信息 – 行偏移
				"fID" : fID,
				"fCusShopID" : shopID,
				"editState" : editState
		};

		var success = function(resultData) {
			var append = event.options && event.options.append;
			data.loadData(resultData, append);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "queryTCommon",
			"params" : params,
			"success" : success
		});
	};

	Model.prototype.bespokeBtnClick = function(event){
		var data = this.comp("ActivityData");
		
		var fType = data.val("fType");
		var fTitle = data.val("fTitle");
		var fStartDate = data.val("fStartDate");
		var fEndDate = data.val("fEndDate");
		var fDescription = data.val("fDescription");
		var fState = data.val("fState");
		
		if(fType+"" == "undefined" || fType+"" == ""){
			justep.Util.hint("必须选择活动类型！", {parent : this.getRootNode()});
			return;
		}
		if(fTitle+"" == "undefined" || fTitle+"" == ""){
			justep.Util.hint("必须填写活动主题！", {parent : this.getRootNode()});
			return;
		}
		if(fStartDate+"" == "undefined" || fStartDate+"" == ""){
			justep.Util.hint("必须选择开始日期！", {parent : this.getRootNode()});
			return;
		}
		if(fEndDate+"" == "undefined" || fEndDate+"" == ""){
			justep.Util.hint("必须选择结束日期！", {parent : this.getRootNode()});
			return;
		}
		if (fStartDate > fEndDate){
			justep.Util.hint("活动开始日期不能大于活动结束日期！", {parent : this.getRootNode()});
			return;
		}
		
		if(fState+"" == "undefined" || fState+"" == ""){
			justep.Util.hint("必须选择活动状态！", {parent : this.getRootNode()});
			return;
		}
		
		
		var params = {		
				"fID" : fID,
				"fCusShopID" : shopID,
				"editState" : editState,
				"fType":fType,
				"fTitle":fTitle,
				"fStartDate":justep.Date.toString(fStartDate, "yyyy-MM-dd"),
				"fEndDate":justep.Date.toString(fEndDate, "yyyy-MM-dd"),
				"fDescription":fDescription,
				"fState":fState
		};
		
		var self = this;

		var success = function(resultData) {
			self.comp("windowReceiver1").windowEnsure(fID);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "updateTOrgnizeActivity",
			"params" : params,
			"success" : success
		});
	};

	return Model;
});