define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Baas = require("$UI/HondaApp/js/baas");
	require("cordova!cordova-plugin-inappbrowser");
	
	var shopID = "";
	var shopName = "";
	var oPhone = "";
	var gType = "", gSallType = "";
	var readStstus = "noReadFile";
	
	
	var Model = function(){
		this.callParent();
	};

	Model.prototype.button1Click = function(event){
		var url = '../HondaApp/indexActivity.w';
        window.location.href = url;
	};

	Model.prototype.windowReceiver1Receive = function(event){
		var status = this.getContext().getRequestParameter("status");
		
		readStstus = event.data.status;
		shopID = event.data.fCusShopID;
		shopName = event.data.fCusShopName;
		oPhone = event.data.fPhone;
		gType = event.data.fType;
		gSallType = event.data.fSallType; 
		
		//需要刷新
		var apointmentData = this.comp("apointmentData");
		var ActivityData = this.comp("ActivityData");
		apointmentData.refreshData();
		ActivityData.refreshData();
		
		
	};

	Model.prototype.modelLoad = function(event){
		if (justep.Browser.isX5App && justep.Browser.isAndroid) {//判断是否app应用并且是android系统
			document.addEventListener("deviceready", function() {        //当设备准备完成时，增加一个事件监听函数
	            var listener = function(){                //定义listener监听者
	                //如果在其他页面，则返回父界面
	                var url = '../HondaApp/indexActivity.w';
	        		window.location.href = url;
	            };
	            document.addEventListener('backbutton', listener, false);
	            $(window).on('beforeunload', function(){
	                    document.removeEventListener('backbutton', listener, false);
	            });
	        }, false);
        }
	};

	Model.prototype.button12Click = function(event){
		this.comp('windowDialog3').open({data:{status:"set"}});
	};

	Model.prototype.button8Click = function(event){
		var url = '../HondaApp/indexActivity.w';
        window.location.href = url;
	};

	Model.prototype.button11Click = function(event){
		this.comp('windowDialog5').open({
			data : {
				fCusShopID : shopID,
				fCusShopName : shopName,
				fPhone : oPhone,
				fType : gType,
				fSallType : gSallType,
				status : "noReadFile"
			}
		});
	};

	Model.prototype.li1Click = function(event){
		this.comp('windowDialog1').open({data:{shopID:shopID}});
	};

	Model.prototype.button3Click = function(event){
		this.comp('windowDialog6').open({data:{shopID:shopID,fID:"",editState:"new"}});
	};

	Model.prototype.button4Click = function(event){
		this.comp('windowDialog2').open({data:{shopID:shopID}});
	};

	Model.prototype.button5Click = function(event){
		var self = this;
		var cData = this.comp("cData");
		var fPhone = cData.val("fPhone");
		var fFramNo = cData.val("fFramNo");
		if(fPhone+"" == "undefined" || fPhone+"" == ""){
			justep.Util.hint("必须填写手机号码！", {parent : this.getRootNode()});
			return;
		}
		
		if(fFramNo+"" != "undefined" && fFramNo+"" != ""){
			if (fFramNo.length < 8){
				justep.Util.hint("必须选择车架号！", {parent : this.getRootNode()});
				return;
			}
		}

		var params = {		
				"fPhone" : fPhone,
				"fFramNo" : fFramNo
		};

		var success = function(resultData) {
			var frameData = self.comp("frameData");
			if (resultData.result == "true"){
				cData.setValue("fPhone", "");
				cData.setValue("fFramNo", "");
				
				frameData.clear();
			}
			
			if (resultData.result == "false1"){
				var sDataStr = resultData.data;
				var strs = sDataStr.split(",");
				for (i=0; i<strs.length; i++ ) {
					frameData.newData();
					frameData.setValue("fCode",strs[i]);
				} 
				
			}
			
			
			justep.Util.hint(resultData.fCaption, {parent : self.getRootNode()});
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "reissueMessage",
			"params" : params,
			"success" : success
		});
		
	};

	Model.prototype.apointmentDataCustomRefresh = function(event){
		if(shopID+"" != "undefined" && shopID+"" != ""){
			var data = event.source;
			var params = {		
				"columns" : Baas.getDataColumns(data),
				"limit" : event.limit,	// 分页信息 – 行数
				"offset" : event.offset,  // 分页信息 – 行偏移
				"fCusShopID" : shopID,
			};
			
			var success = function(resultData) {
				var append = event.options && event.options.append;
				data.loadData(resultData, append);
			};
			Baas.sendRequest({
				"url" : "/honda",
				"action" : "queryTUserAppointment",
				"params" : params,
				"success" : success
			});
		}
		
	};
	
	
	Model.prototype.setColor = function(value){		
		var ret = null;
		if(value == "待确认"){
			ret = {'color':'#EEB422'};//黄色
		}else if(value == "成功预约"){
			ret = {'color':'#00FF00'};//绿色
		}else if(value == "预约已满" || value == "用户取消"){
			ret = {'color':'#FF0000'};//红色
		}
		return ret;
	};

	Model.prototype.a1Click = function(event){
		var phone = event.bindingContext.$object.val("fContactNumber");
		window.location.href = "tel:"+phone;
	};

	Model.prototype.button2Click = function(event){
		this.updateTUserAppointment(event, "成功预约");
	};

	Model.prototype.addCartBtnClick = function(event){
		this.updateTUserAppointment(event, "预约已满");
	};

	Model.prototype.updateTUserAppointment = function(event,fStatus){
		var apointmentData = this.comp("apointmentData");
		var row = event.bindingContext.$object;
		var fID = row.getID();
		var params = {
				"fID" : fID,
				"fStatus": fStatus
		};
		var success = function(resultData) {
			apointmentData.refreshData();
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "updateTUserAppointment",
			"params" : params,// "async" : true,
			"success" : success
		});
	};

	Model.prototype.ActivityDataCustomRefresh = function(event){
		if(shopID+"" != "undefined" && shopID+"" != ""){
			var data = event.source;
			var params = {		
				"columns" : Baas.getDataColumns(data),
				"limit" : event.limit,	// 分页信息 – 行数
				"offset" : event.offset,  // 分页信息 – 行偏移
				"fID" : "",
				"fCusShopID" : shopID
			};
			
			var success = function(resultData) {
				var append = event.options && event.options.append;
				data.loadData(resultData, append);
			};
			Baas.sendRequest({
				"url" : "/honda",
				"action" : "queryTOrgnizeActivity",
				"params" : params,
				"success" : success
			});
		}
	};

	Model.prototype.li4Click = function(event){
		var row = event.bindingContext.$object;
		var fID = row.getID();
		this.comp('windowDialog6').open({data:{shopID:shopID,fID:fID,editState:"edit"}});
	};

	Model.prototype.windowDialog6Receive = function(event){
		var ActivityData = this.comp("ActivityData");
		ActivityData.refreshData();
	};

	Model.prototype.cDataValueChanged = function(event){
		var data = event.source;
		var frameData = this.comp("frameData");
		if (event.col == "fPhone"){
			data.val("fFramNo", "");
			frameData.clear();
		}
	};

	return Model;
});