define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	
	var baas = {
		BASE_URL : "/baas",

		/**
		 * options = { "async" : 是否异步请求，默认false "url" : 服务端请求地址，不包含BASE_URL
		 * "action" : 动作标识 "params" : 动作对应的参数 "success" :
		 * 请求成功后的回调，参数(resultData, xhr) "error" : 请求失败后的回调，参数(msg, xhr) }
		 */
		sendRequest : function(options) {
			var self = this;
			var ajaxTimeOut = $.ajax({
				"type" : "post",
				"async" : options.async ? options.async : false,
				"timeout" : 50000,
				"dataType" : "json",
				"url" : this.BASE_URL + options.url,
				"data" : {
					"action" : options.action,
					// 序列化参数JSON字符串
					"params" : JSON.stringify(options.params)
				},
				"complete" : function(xhr, status) {
					
					// alert("状态："+status);
					if (status == "timeout") {// 超时,status还有success,error等值的情况
						ajaxTimeOut.abort(); // 取消请求
						alert("网络连接超时，请检查网络！");
						/*justep.Util.hint("网络连接超时，请检查网络！！", {
							parent : self.getRootNode()
						});*/
						
						//justep.Util.hint("网络连接超时，请检查网络！！");
					} else {

						if (xhr.readyState == 4 && xhr.status == 200) {
							if (options.success) {
								options.success.call(this, xhr.responseJSON, xhr);
							} else {
								justep.Util.hint("网络连接异常,请检查网络！", {
									"type" : "danger"
								});
							}
						} else {
							var msg = self.getErrorMsg(xhr);

							justep.Util.hint("网络连接异常,请检查网络！", {
								"type" : "danger"
							});

							/*
							 * alert("error"+options.error); if (options.error) {
							 * options.error.call(this, msg, xhr); } else {
							 * self.showError(msg); }
							 */
						}
					}
				}
			});
		},

		getErrorMsg : function(xhr) {
			return $(xhr.responseText).filter("h1:first").text() || xhr.statusText;
		},

		showError : function(msg) {
			justep.Util.hint("网络连接异常,请检查网络！", {
				"type" : "danger"
			});
		},
		getDataColumns : function(data) {
			var columns = {};
			$.each(data.defCols, function(key) {
				columns[key] = {
					"name" : data.defCols[key]["name"],
					"type" : data.defCols[key]["type"]
				};
			});
			return columns;
		}

	};

	return baas;
});