define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Baas = require("$UI/HondaApp/js/baas");
	var cusShopID = "";
	var cusShopName = "";
	var self;
	var Model = function(){
		this.callParent();
		this.showBtn = justep.Bind.observable(false);
	};
	Model.prototype.modelLoad = function(event){
		self = this;
		if (justep.Browser.isX5App && justep.Browser.isAndroid) {//判断是否app应用并且是android系统
			if(!this.showBtn.get()){
            	this.showBtn.set(!self.showBtn.get());
            }
		}
	};//https://od.lk/s/Nl82NjQ1MTIxN18/honda111.plist
	Model.prototype.windowReceiver1Receive = function(event){
		cusShopID = event.data.fCusShopID;
		cusShopName = event.data.fCusShopName;
		var userData = this.comp("userData");
		userData.refreshData();
	};
	Model.prototype.userDataCustomRefresh = function(event){
		var data = event.source;
		var params = {		
			"columns" : Baas.getDataColumns(data),
			"limit" : event.limit,	// 分页信息 – 行数
			"offset" : event.offset,  // 分页信息 – 行偏移
			"fCusShopID" : cusShopID,
			"fSallType" : "1"
		};
		
		var success = function(resultData) {
			var append = event.options && event.options.append;
			data.loadData(resultData, append);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "queryTRTLUsers",
			"params" : params,
			"success" : success
		});
	};

	Model.prototype.button10Click = function(event){
		var userData = this.comp("userData");
		var row = event.bindingContext.$object;
		var dCusShopID = row.val("fCusShopID");
		var fid = row.val("fID");
		justep.Util.confirm("确定要删除吗？",onOk,onCancel,{ parent: this.getRootNode()});//{ parent: this.getRootNode()}
		function onOk(){
			updateDate("delete",fid,"","","","","",dCusShopID,"");
			userData.refreshData();
			var tempData = self.comp("tempData");
			tempData.setValue("fID","");
			tempData.setValue("fPsnName","");
			tempData.setValue("fPhone","");
			tempData.setValue("fCusShopID","");
			tempData.setValue("fSallName","");
			self.comp("button3").set({label:"手动新增"});
		}
		function onCancel(){
			//alert("cancel");
		}
	};
	Model.prototype.button1Click = function(event){
		var tempData = this.comp("tempData");
		var row = event.bindingContext.$object;
		tempData.setValue("fID",row.val("fID"));
		tempData.setValue("fPsnName",row.val("fPsnName"));
		tempData.setValue("fPhone",row.val("fPhone"));
		tempData.setValue("fCusShopID",row.val("fCusShopID"));
		tempData.setValue("fSallName",row.val("fSallName"));
		this.comp("button3").set({label:"修改并保存"});
		
	};
	Model.prototype.button3Click = function(event){
		var tempData = this.comp("tempData");
		var btnType = this.comp("button3").get("label");
		var name = tempData.getValue("fPsnName");
		var phone = tempData.getValue("fPhone");
		var sallName = tempData.getValue("fSallName");
		var userData = this.comp("userData");
		if(name+"" == "" || phone+"" == ""){
			justep.Util.hint("用户名称和手机号码不能为空！");
			return;
		}
		var telReg = !!phone.match(/^1\d{10}$/);
		//var telReg = !!phone.match(/^(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
		//如果手机号码不能通过验证
		if(telReg == false){
			justep.Util.hint("手机号码格式不对，不能保存！", { parent: this.getRootNode()});
			return;
		}
		//window.device.uuid
		if(btnType == "手动新增"){
			updateDate("insert","",name,phone,sallName,"1","1",cusShopID,cusShopName);
		}else{
			var fid = tempData.getValue("fID");
			var uName = tempData.getValue("fPsnName");
			var uPhone = tempData.getValue("fPhone");
			var uCusShopID = tempData.getValue("fCusShopID");
			var uSallName = tempData.getValue("fSallName");
			updateDate("update",fid,uName,uPhone,uSallName,"","",uCusShopID,"");
			this.comp("button3").set({label:"手动新增"});
		}
		userData.refreshData();
		tempData.setValue("fPsnName","");
		tempData.setValue("fPhone","");
		tempData.setValue("fSallName","");
	};
	function updateDate(usecode,fid,fname,fphone,fsallname,ftype,fsalltype,fshopcode,fshopname){
		var userData = self.comp("userData");
		var params = {
			"usecode" : usecode,
			"fid" : fid,
			"fname" : fname,
			"fphone" : fphone,
			"fsallname" : fsallname,
			"ftype" : ftype,
			"fsalltype" : fsalltype,
			"fshopcode" : fshopcode,
			"fshopname" : fshopname
		};
		var success = function(resultData) {
			if(resultData.result == "success"){
				//alert(usecode+" "+resultData.result);
			}
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "updateTRTLUser",
			"params" : params,
			"success" : success
		});
	}
	Model.prototype.button4Click = function(event){
		this.comp("windowReceiver1").windowCancel();
	};
	Model.prototype.button2Click = function(event){
		if (justep.Browser.isX5App && justep.Browser.isAndroid) {//判断是否app应用并且是android系统
			this.comp('windowDialog1').open(null);
		}else{
			justep.Util.hint("IOS版暂不提供此功能！", { parent: this.getRootNode()});
		}
	};
	Model.prototype.windowDialog1Receive = function(event){
		var res = event.data;
		var userData = self.comp("userData");
		//alert("主窗体json="+res);
		if(res != null){
			var josnstr = eval("(" + res + ")");
			for(var i=0;i<josnstr.length;i++){
				var name = josnstr[i].name;
				var phone = josnstr[i].phone;
				updateDate("insert","",name,phone,"请修改二次店名","1","1",cusShopID,cusShopName);
			}
		}
		userData.refreshData();
	};
	return Model;
});