define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Baas = require("$UI/HondaApp/js/baas");
	var cusShopID = "";
	var cusShopName = "";
	var upPhoneNO = "";
	var upPsnName = "";
	var self;
	var Model = function() {
		this.callParent();
		this.showBtn = justep.Bind.observable(false);
	};
	Model.prototype.modelLoad = function(event) {
		self = this;
		if (justep.Browser.isX5App && justep.Browser.isAndroid) {// 判断是否app应用并且是android系统
			if (!this.showBtn.get()) {
				this.showBtn.set(!self.showBtn.get());
			}
		}
	};
	Model.prototype.windowReceiver1Receive = function(event) {
		cusShopID = event.data.fCusShopID;
		cusShopName = event.data.fCusShopName;
		upPhoneNO = event.data.fPhone;
		upPsnName = event.data.fPsnName;
		var tempData = this.comp("tempData");
		tempData.setValue("fCusShopID", cusShopID);
		tempData.setValue("fCusShopName", cusShopName);
		tempData.setValue("fUpPhoneNO", upPhoneNO);
		tempData.setValue("fUpPsnName", upPsnName);
		var workPsnData = this.comp("workPsnData");
		workPsnData.refreshData();
	};
	Model.prototype.workPsnDataCustomRefresh = function(event) {
		var data = event.source;
		var params = {
			"columns" : Baas.getDataColumns(data),
			"limit" : event.limit, // 分页信息 – 行数
			"offset" : event.offset, // 分页信息 – 行偏移
			"fCusShopID" : cusShopID,
			"fCusShopName" : cusShopName
		};

		var success = function(resultData) {
			var append = event.options && event.options.append;
			data.loadData(resultData, append);
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "queryWorkPerson",
			"params" : params,
			"success" : success
		});
	};

	Model.prototype.button10Click = function(event) {
		var workPsnData = this.comp("workPsnData");
		var row = event.bindingContext.$object;
		var fCusShopID = row.val("fCusShopID");
		var fid = row.val("fWorkerCode");
		// //(confirm("确认要删除吗？"));
		justep.Util.confirm("确定要删除吗？", onOk, onCancel, {
			parent : this.getRootNode()
		});
		function onOk() {
			updateDate("delete", fid, "", "", "", fCusShopID, "");
			workPsnData.refreshData();
			var tempData = self.comp("tempData");
			tempData.setValue("fWorkerCode", "");
			tempData.setValue("fWorker", "");
			tempData.setValue("fCusShopID", "");
			self.comp("button3").set({
				label : "手动新增"
			});
		}
		function onCancel() {
			// //("cancel");
		}
	};
	Model.prototype.button1Click = function(event) {
		var tempData = this.comp("tempData");
		var row = event.bindingContext.$object;
		tempData.setValue("fWorkerCode", row.val("fWorkerCode"));
		tempData.setValue("fWorker", row.val("fWorker"));
		tempData.setValue("fCusShopID", row.val("fCusShopID"));
		this.comp("button3").set({
			label : "修改并保存"
		});

	};
	Model.prototype.button3Click = function(event) {
		var tempData = this.comp("tempData");
		var btnType = this.comp("button3").get("label");
		var fWorker = tempData.getValue("fWorker");
		var workPsnData = this.comp("workPsnData");
		if (fWorker + "" == "") {
			justep.Util.hint("维修技师姓名不能为空！");
			return;
		}
		// window.device.uuid
		if (btnType == "手动新增") {
			updateDate("insert", "", fWorker, upPhoneNO, upPsnName, cusShopID, cusShopName);
		} else {
			var uWorkerCode = tempData.getValue("fWorkerCode");
			var uWorker = tempData.getValue("fWorker");
			var uCusShopID = tempData.getValue("fCusShopID");
			updateDate("update", uWorkerCode, uWorker, upPhoneNO, upPsnName, uCusShopID, "");
			this.comp("button3").set({
				label : "手动新增"
			});
		}
		workPsnData.refreshData();
		tempData.setValue("fWorker", "");
	};
	function updateDate(usecode, workercode, workername, fphone, fpsnname, fshopcode, fshopname) {
		var workPsnData = self.comp("workPsnData");
		var params = {
			"usecode" : usecode,
			"workercode" : workercode,
			"workername" : workername,
			"fphone" : fphone,
			"fpsnname" : fpsnname,
			"fshopcode" : fshopcode,
			"fshopname" : fshopname
		};
		var success = function(resultData) {
			if (resultData.result == "success") {
				// //(usecode+" "+resultData.result);
			}
		};
		Baas.sendRequest({
			"url" : "/honda",
			"action" : "updateWorkPerson",
			"params" : params,
			"success" : success
		});
	}
	Model.prototype.button4Click = function(event) {
		this.comp("windowReceiver1").windowCancel();
	};
	Model.prototype.button2Click = function(event) {
		// this.comp('windowDialog1').open(null);
		if (justep.Browser.isX5App && justep.Browser.isAndroid) {// 判断是否app应用并且是android系统
			this.comp('windowDialog1').open(null);
		} else {
			justep.Util.hint("IOS版暂不提供此功能！", {
				parent : this.getRootNode()
			});
		}
	};
	Model.prototype.windowDialog1Receive = function(event) {
		var res = event.data;
		var workPsnData = self.comp("workPsnData");
		// //("主窗体json="+res);
		if (res != null) {
			var josnstr = eval("(" + res + ")");
			for ( var i = 0; i < josnstr.length; i++) {
				var name = josnstr[i].name;
				// var phone = josnstr[i].phone;
				updateDate("insert", "", name, upPhoneNO, upPsnName, cusShopID, cusShopName);
			}
		}
		workPsnData.refreshData();
	};
	return Model;
});